diff --git a/gdb/amd64-linux-tdep.c b/gdb/amd64-linux-tdep.c
index 7e0900dc6f9..e149034de21 100644
--- a/gdb/amd64-linux-tdep.c
+++ b/gdb/amd64-linux-tdep.c
@@ -1579,37 +1579,6 @@ amd64_linux_record_signal (struct gdbarch *gdbarch,
   return 0;
 }
 
-const target_desc *
-amd64_linux_read_description (uint64_t xcr0_features_bit, bool is_x32)
-{
-  static target_desc *amd64_linux_tdescs \
-    [2/*AVX*/][2/*MPX*/][2/*AVX512*/][2/*PKRU*/] = {};
-  static target_desc *x32_linux_tdescs \
-    [2/*AVX*/][2/*AVX512*/][2/*PKRU*/] = {};
-
-  target_desc **tdesc;
-
-  if (is_x32)
-    {
-      tdesc = &x32_linux_tdescs[(xcr0_features_bit & X86_XSTATE_AVX) ? 1 : 0 ]
-	[(xcr0_features_bit & X86_XSTATE_AVX512) ? 1 : 0]
-	[(xcr0_features_bit & X86_XSTATE_PKRU) ? 1 : 0];
-    }
-  else
-    {
-      tdesc = &amd64_linux_tdescs[(xcr0_features_bit & X86_XSTATE_AVX) ? 1 : 0]
-	[(xcr0_features_bit & X86_XSTATE_MPX) ? 1 : 0]
-	[(xcr0_features_bit & X86_XSTATE_AVX512) ? 1 : 0]
-	[(xcr0_features_bit & X86_XSTATE_PKRU) ? 1 : 0];
-    }
-
-  if (*tdesc == NULL)
-    *tdesc = amd64_create_target_description (xcr0_features_bit, is_x32,
-					      true, true);
-
-  return *tdesc;
-}
-
 /* Get Linux/x86 target description from core dump.  */
 
 static const struct target_desc *
diff --git a/gdb/i386-linux-tdep.c b/gdb/i386-linux-tdep.c
index f5f7a36bf36..ed1442236e8 100644
--- a/gdb/i386-linux-tdep.c
+++ b/gdb/i386-linux-tdep.c
@@ -681,29 +681,12 @@ i386_linux_core_read_x86_xsave_layout (struct gdbarch *gdbarch,
 					  layout) != 0;
 }
 
-/* See i386-linux-tdep.h.  */
+/* See nat/x86-linux-tdesc.h.  */
 
-const struct target_desc *
-i386_linux_read_description (uint64_t xcr0)
+void
+x86_linux_post_init_tdesc (target_desc *tdesc, bool is_64bit)
 {
-  if (xcr0 == 0)
-    return NULL;
-
-  static struct target_desc *i386_linux_tdescs \
-    [2/*X87*/][2/*SSE*/][2/*AVX*/][2/*MPX*/][2/*AVX512*/][2/*PKRU*/] = {};
-  struct target_desc **tdesc;
-
-  tdesc = &i386_linux_tdescs[(xcr0 & X86_XSTATE_X87) ? 1 : 0]
-    [(xcr0 & X86_XSTATE_SSE) ? 1 : 0]
-    [(xcr0 & X86_XSTATE_AVX) ? 1 : 0]
-    [(xcr0 & X86_XSTATE_MPX) ? 1 : 0]
-    [(xcr0 & X86_XSTATE_AVX512) ? 1 : 0]
-    [(xcr0 & X86_XSTATE_PKRU) ? 1 : 0];
-
-  if (*tdesc == NULL)
-    *tdesc = i386_create_target_description (xcr0, true, false);
-
-  return *tdesc;
+  /* Nothing.  */
 }
 
 /* Get Linux/x86 target description from core dump.  */
@@ -716,7 +699,10 @@ i386_linux_core_read_description (struct gdbarch *gdbarch,
   /* Linux/i386.  */
   x86_xsave_layout layout;
   uint64_t xcr0 = i386_linux_core_read_xsave_info (abfd, layout);
-  const struct target_desc *tdesc = i386_linux_read_description (xcr0);
+
+  const struct target_desc *tdesc;
+  if (xcr0 != 0)
+    tdesc = i386_linux_read_description (xcr0);
 
   if (tdesc != NULL)
     return tdesc;
diff --git a/gdb/nat/x86-linux-tdesc.c b/gdb/nat/x86-linux-tdesc.c
index 78d22f55d67..297d1873680 100644
--- a/gdb/nat/x86-linux-tdesc.c
+++ b/gdb/nat/x86-linux-tdesc.c
@@ -38,6 +38,8 @@
 #include <sys/user.h>
 #include <sys/user.h>
 
+#ifndef IN_PROCESS_AGENT
+
 /* See nat/x86-linux-tdesc.h.  */
 
 const target_desc *
@@ -116,3 +118,288 @@ x86_linux_tdesc_for_tid (int tid, enum tribool *have_ptrace_getregset,
 
   gdb_assert_not_reached ("failed to return tdesc");
 }
+
+#endif /* !IN_PROCESS_AGENT */
+
+
+
+/* A structure used to describe a single cpu feature that might, or might
+   not, be checked for when creating a target description for one of i386,
+   amd64, or x32.  */
+
+struct x86_tdesc_feature {
+  /* The cpu feature mask.  This is a mask against an xcr0 value.  */
+  uint64_t feature;
+
+  /* Is this feature checked when creating an i386 target description.  */
+  bool is_i386;
+
+  /* Is this feature checked when creating an amd64 target description.  */
+  bool is_amd64;
+
+  /* Is this feature checked when creating an x32 target description.  */
+  bool is_x32;
+};
+
+/* A constant table that describes all of the cpu features that are
+   checked when building a target description for i386, amd64, or x32.  */
+
+static constexpr x86_tdesc_feature x86_linux_all_tdesc_features[] = {
+  /* Feature,           i386,	amd64,	x32.  */
+  { X86_XSTATE_PKRU,	true,	true, 	true },
+  { X86_XSTATE_AVX512,	true,	true, 	true },
+  { X86_XSTATE_AVX,	true,	true, 	true },
+  { X86_XSTATE_MPX,	true,	true, 	false },
+  { X86_XSTATE_SSE,	true,	false, 	false },
+  { X86_XSTATE_X87,	true,	false, 	false }
+};
+
+/* Return a compile time constant which is a mask of all the cpu features
+   that are checked for when building an i386 target description.  */
+
+static constexpr uint64_t
+x86_linux_i386_tdesc_feature_mask ()
+{
+  uint64_t mask = 0;
+
+  for (const auto &entry : x86_linux_all_tdesc_features)
+    if (entry.is_i386)
+      mask |= entry.feature;
+
+  return mask;
+}
+
+/* Return a compile time constant which is a mask of all the cpu features
+   that are checked for when building an amd64 target description.  */
+
+static constexpr uint64_t
+x86_linux_amd64_tdesc_feature_mask ()
+{
+  uint64_t mask = 0;
+
+  for (const auto &entry : x86_linux_all_tdesc_features)
+    if (entry.is_amd64)
+      mask |= entry.feature;
+
+  return mask;
+}
+
+/* Return a compile time constant which is a mask of all the cpu features
+   that are checked for when building an x32 target description.  */
+
+static constexpr uint64_t
+x86_linux_x32_tdesc_feature_mask ()
+{
+  uint64_t mask = 0;
+
+  for (const auto &entry : x86_linux_all_tdesc_features)
+    if (entry.is_x32)
+      mask |= entry.feature;
+
+  return mask;
+}
+
+/* Return a compile time constant which is a count of the number of cpu
+   features that are checked for when building an i386 target description.  */
+
+static constexpr int
+x86_linux_i386_tdesc_count ()
+{
+  uint64_t count = 0;
+
+  for (const auto &entry : x86_linux_all_tdesc_features)
+    if (entry.is_i386)
+      ++count;
+
+  gdb_assert (count > 0);
+
+  return (1 << count);
+}
+
+/* Return a compile time constant which is a count of the number of cpu
+   features that are checked for when building an amd64 target description.  */
+
+static constexpr int
+x86_linux_amd64_tdesc_count ()
+{
+  uint64_t count = 0;
+
+  for (const auto &entry : x86_linux_all_tdesc_features)
+    if (entry.is_amd64)
+      ++count;
+
+  gdb_assert (count > 0);
+
+  return (1 << count);
+}
+
+/* Return a compile time constant which is a count of the number of cpu
+   features that are checked for when building an x32 target description.  */
+
+static constexpr int
+x86_linux_x32_tdesc_count ()
+{
+  uint64_t count = 0;
+
+  for (const auto &entry : x86_linux_all_tdesc_features)
+    if (entry.is_x32)
+      ++count;
+
+  gdb_assert (count > 0);
+
+  return (1 << count);
+}
+
+#ifdef IN_PROCESS_AGENT
+
+/* See linux-x86-tdesc.h.  */
+
+int
+x86_linux_amd64_ipa_tdesc_count ()
+{
+  return x86_linux_amd64_tdesc_count ();
+}
+
+/* See linux-x86-tdesc.h.  */
+
+int
+x86_linux_x32_ipa_tdesc_count ()
+{
+  return x86_linux_x32_tdesc_count ();
+}
+
+/* See linux-x86-tdesc.h.  */
+
+int
+x86_linux_i386_ipa_tdesc_count ()
+{
+  return x86_linux_i386_tdesc_count ();
+}
+
+#endif /* IN_PROCESS_AGENT */
+
+/* Convert an xcr0 value into an integer.  The integer will be passed to
+   the in-process-agent where it will then be passed to
+   x86_linux_tdesc_idx_to_xcr0 to get back the xcr0 value.  */
+
+int
+x86_linux_xcr0_to_tdesc_idx (uint64_t xcr0)
+{
+  /* The following table shows which features are checked for when creating
+     the target descriptions (see nat/x86-linux-tdesc.c), the feature order
+     represents the bit order within the generated index number.
+
+     i386  | x87 sse mpx avx avx512 pkru
+     amd64 |         mpx avx avx512 pkru
+     i32   |             avx avx512 pkru
+
+     The features are ordered so that for each mode (i386, amd64, i32) the
+     generated index will form a continuous range.  */
+
+  int idx = 0;
+
+  for (int i = 0; i < ARRAY_SIZE (x86_linux_all_tdesc_features); ++i)
+    {
+      if ((xcr0 & x86_linux_all_tdesc_features[i].feature) != 0)
+	idx |= (1 << i);
+    }
+
+  return idx;
+}
+
+
+#ifdef IN_PROCESS_AGENT
+
+/* Convert an index number (as returned from x86_linux_xcr0_to_tdesc_idx)
+   into an xcr0 value which can then be used to create a target
+   description.  */
+
+uint64_t
+x86_linux_tdesc_idx_to_xcr0 (int idx)
+{
+  uint64_t xcr0 = 0;
+
+  for (int i = 0; i < ARRAY_SIZE (x86_linux_all_tdesc_features); ++i)
+    {
+      if ((idx & (1 << i)) != 0)
+	xcr0 |= x86_linux_all_tdesc_features[i].feature;
+    }
+
+  return xcr0;
+}
+
+#endif /* IN_PROCESS_AGENT */
+
+#if defined __i386__ || !defined IN_PROCESS_AGENT
+
+/* A cache of all possible i386 target descriptions.  */
+
+static struct target_desc *i386_tdescs[x86_linux_i386_tdesc_count ()] = { };
+
+/* See nat/x86-linux-tdesc.h.  */
+
+const struct target_desc *
+i386_linux_read_description (uint64_t xcr0)
+{
+  xcr0 &= x86_linux_i386_tdesc_feature_mask ();
+  int idx = x86_linux_xcr0_to_tdesc_idx (xcr0);
+
+  gdb_assert (idx >= 0 && idx < x86_linux_i386_tdesc_count ());
+
+  target_desc **tdesc = &i386_tdescs[idx];
+
+  if (*tdesc == nullptr)
+    {
+      *tdesc = i386_create_target_description (xcr0, true, false);
+
+      x86_linux_post_init_tdesc (*tdesc, false);
+    }
+
+  return *tdesc;
+}
+#endif
+
+#ifdef __x86_64__
+
+/* A cache of all possible amd64 target descriptions.  */
+
+static target_desc *amd64_tdescs[x86_linux_amd64_tdesc_count ()] = { };
+
+/* A cache of all possible x32 target descriptions.  */
+
+static target_desc *x32_tdescs[x86_linux_x32_tdesc_count ()] = { };
+
+/* See nat/x86-linux-tdesc.h.  */
+
+const struct target_desc *
+amd64_linux_read_description (uint64_t xcr0, bool is_x32)
+{
+  if (is_x32)
+    xcr0 &= x86_linux_x32_tdesc_feature_mask ();
+  else
+    xcr0 &= x86_linux_amd64_tdesc_feature_mask ();
+
+  int idx = x86_linux_xcr0_to_tdesc_idx (xcr0);
+
+  if (is_x32)
+    gdb_assert (idx >= 0 && idx < x86_linux_x32_tdesc_count ());
+  else
+    gdb_assert (idx >= 0 && idx < x86_linux_amd64_tdesc_count ());
+
+  target_desc **tdesc = nullptr;
+
+  if (is_x32)
+    tdesc = &x32_tdescs[idx];
+  else
+    tdesc = &amd64_tdescs[idx];
+
+  if (*tdesc == nullptr)
+    {
+      *tdesc = amd64_create_target_description (xcr0, is_x32, true, true);
+
+      x86_linux_post_init_tdesc (*tdesc, true);
+    }
+  return *tdesc;
+}
+
+#endif
diff --git a/gdb/nat/x86-linux-tdesc.h b/gdb/nat/x86-linux-tdesc.h
index 3727a8bf95e..648fe0ed0b2 100644
--- a/gdb/nat/x86-linux-tdesc.h
+++ b/gdb/nat/x86-linux-tdesc.h
@@ -24,6 +24,8 @@
 
 struct target_desc;
 
+#ifndef IN_PROCESS_AGENT
+
 /* Return the target description for Linux thread TID.
 
    When *HAVE_PTRACE_GETREGSET is TRIBOOL_UNKNOWN then the current value of
@@ -57,19 +59,57 @@ x86_linux_tdesc_for_tid (int tid, enum tribool *have_ptrace_getregset,
 			 gdb::function_view<void (uint64_t)> xcr0_init_cb,
 			 const char *error_msg, uint64_t *xcr0_storage);
 
+#endif /* !IN_PROCESS_AGENT */
+
 #ifdef __x86_64__
 
-/* Return the right amd64-linux target descriptions according to
-   XCR0_FEATURES_BIT and IS_X32.  This is implemented separately in both
-   GDB and gdbserver.  */
+/* Return the AMD64 target descriptions corresponding to XCR0 and IS_X32.  */
 
-extern const target_desc *amd64_linux_read_description
-	(uint64_t xcr0_features_bit, bool is_x32);
+extern const target_desc *amd64_linux_read_description (uint64_t xcr0,
+							bool is_x32);
 
-#endif
+#endif /* __x86_64__ */
+
+/* Return the i386 target description corresponding to XCR0.  */
 
-/* Return the target description according to XCR0.  This is implemented
-   separately in both GDB and gdbserver.  */
 extern const struct target_desc *i386_linux_read_description (uint64_t xcr0);
 
+/* This function is called from amd64_linux_read_description and
+   i386_linux_read_description after a new target description has been
+   created, TDESC is the new target description, IS_64BIT will be true
+   when called from amd64_linux_read_description, otherwise IS_64BIT will
+   be false.  If the *_linux_read_description functions found a cached
+   target description then this function will not be called.
+
+   Both GDB and gdbserver have their own implementations of this
+   function.  */
+
+extern void x86_linux_post_init_tdesc (target_desc *tdesc, bool is_64bit);
+
+/* Convert an xcr0 value into an integer.  The integer will be passed to
+   the in-process-agent where it will then be passed to
+   x86_linux_tdesc_idx_to_xcr0 to get back the xcr0 value.  */
+
+extern int x86_linux_xcr0_to_tdesc_idx (uint64_t xcr0);
+
+
+#ifdef IN_PROCESS_AGENT
+
+/* Convert an index number (as returned from x86_linux_xcr0_to_tdesc_idx)
+   into an xcr0 value which can then be used to create a target
+   description.  */
+
+extern uint64_t x86_linux_tdesc_idx_to_xcr0 (int idx);
+
+/* Within the in-process-agent we need to pre-initialise all of the target
+   descriptions, to do this we need to know how many target descriptions
+   there are for each different target type.  These functions return the
+   target description count for the relevant target.  */
+
+extern int x86_linux_amd64_ipa_tdesc_count ();
+extern int x86_linux_x32_ipa_tdesc_count ();
+extern int x86_linux_i386_ipa_tdesc_count ();
+
+#endif /* IN_PROCESS_AGENT */
+
 #endif /* NAT_X86_LINUX_TDESC_H */
diff --git a/gdbserver/Makefile.in b/gdbserver/Makefile.in
index d12f8746611..c97649378e8 100644
--- a/gdbserver/Makefile.in
+++ b/gdbserver/Makefile.in
@@ -517,6 +517,10 @@ gdbsupport/%-ipa.o: ../gdbsupport/%.cc
 	$(IPAGENT_COMPILE) $<
 	$(POSTCOMPILE)
 
+nat/%-ipa.o: ../gdb/nat/%.c
+	$(IPAGENT_COMPILE) $<
+	$(POSTCOMPILE)
+
 %-ipa.o: ../gdb/%.c
 	$(IPAGENT_COMPILE) -x c++ $<
 	$(POSTCOMPILE)
diff --git a/gdbserver/configure.srv b/gdbserver/configure.srv
index 7a2702d78bf..36a457f21ed 100644
--- a/gdbserver/configure.srv
+++ b/gdbserver/configure.srv
@@ -116,6 +116,7 @@ case "${gdbserver_host}" in
 			srv_linux_btrace=yes
 			ipa_obj="linux-i386-ipa.o linux-x86-tdesc-ipa.o"
 			ipa_obj="${ipa_obj} arch/i386-ipa.o"
+			ipa_obj="${ipa_obj} nat/x86-linux-tdesc-ipa.o"
 			;;
   i[34567]86-*-mingw*)	srv_regobj=""
 			srv_tgtobj="x86-low.o nat/x86-dregs.o win32-low.o"
@@ -380,6 +381,7 @@ case "${gdbserver_host}" in
 			srv_linux_btrace=yes
 			ipa_obj="linux-amd64-ipa.o linux-x86-tdesc-ipa.o"
 			ipa_obj="${ipa_obj} arch/amd64-ipa.o"
+			ipa_obj="${ipa_obj} nat/x86-linux-tdesc-ipa.o"
 			;;
   x86_64-*-mingw*)	srv_regobj=""
 			srv_tgtobj="x86-low.o nat/x86-dregs.o"
diff --git a/gdbserver/linux-amd64-ipa.cc b/gdbserver/linux-amd64-ipa.cc
index 42de7d2da16..afa6aab5bab 100644
--- a/gdbserver/linux-amd64-ipa.cc
+++ b/gdbserver/linux-amd64-ipa.cc
@@ -21,7 +21,6 @@
 #include "server.h"
 #include <sys/mman.h>
 #include "tracepoint.h"
-#include "linux-x86-tdesc.h"
 #include "gdbsupport/x86-xstate.h"
 #include "nat/x86-linux-tdesc.h"
 
diff --git a/gdbserver/linux-i386-ipa.cc b/gdbserver/linux-i386-ipa.cc
index 246bcb9813b..f6d26f784af 100644
--- a/gdbserver/linux-i386-ipa.cc
+++ b/gdbserver/linux-i386-ipa.cc
@@ -21,7 +21,6 @@
 #include "server.h"
 #include <sys/mman.h>
 #include "tracepoint.h"
-#include "linux-x86-tdesc.h"
 #include "gdbsupport/x86-xstate.h"
 #include "nat/x86-linux-tdesc.h"
 
diff --git a/gdbserver/linux-x86-low.cc b/gdbserver/linux-x86-low.cc
index 6dbefdb2f26..7134d20dd7f 100644
--- a/gdbserver/linux-x86-low.cc
+++ b/gdbserver/linux-x86-low.cc
@@ -47,7 +47,6 @@
 #include "nat/linux-nat.h"
 #include "nat/x86-linux.h"
 #include "nat/x86-linux-dregs.h"
-#include "linux-x86-tdesc.h"
 #include "nat/x86-linux-tdesc.h"
 
 #ifdef __x86_64__
diff --git a/gdbserver/linux-x86-tdesc.cc b/gdbserver/linux-x86-tdesc.cc
index 87cf368a336..39d1d51b8c0 100644
--- a/gdbserver/linux-x86-tdesc.cc
+++ b/gdbserver/linux-x86-tdesc.cc
@@ -19,292 +19,19 @@
 
 #include "server.h"
 #include "tdesc.h"
-#include "linux-x86-tdesc.h"
-#include "arch/i386.h"
-#include "gdbsupport/x86-xstate.h"
-#ifdef __x86_64__
-#include "arch/amd64.h"
-#endif
 #include "x86-tdesc.h"
 #include "nat/x86-linux-tdesc.h"
 
-/* A structure used to describe a single cpu feature that might, or might
-   not, be checked for when creating a target description for one of i386,
-   amd64, or x32.  */
-
-struct x86_tdesc_feature {
-  /* The cpu feature mask.  This is a mask against an xcr0 value.  */
-  uint64_t feature;
-
-  /* Is this feature checked when creating an i386 target description.  */
-  bool is_i386;
-
-  /* Is this feature checked when creating an amd64 target description.  */
-  bool is_amd64;
-
-  /* Is this feature checked when creating an x32 target description.  */
-  bool is_x32;
-};
-
-/* A constant table that describes all of the cpu features that are
-   checked when building a target description for i386, amd64, or x32.  */
-
-static constexpr x86_tdesc_feature x86_linux_all_tdesc_features[] = {
-  /* Feature,           i386,	amd64,	x32.  */
-  { X86_XSTATE_PKRU,	true,	true, 	true },
-  { X86_XSTATE_AVX512,	true,	true, 	true },
-  { X86_XSTATE_AVX,	true,	true, 	true },
-  { X86_XSTATE_MPX,	true,	true, 	false },
-  { X86_XSTATE_SSE,	true,	false, 	false },
-  { X86_XSTATE_X87,	true,	false, 	false }
-};
-
-/* Return a compile time constant which is a mask of all the cpu features
-   that are checked for when building an i386 target description.  */
-
-static constexpr uint64_t
-x86_linux_i386_tdesc_feature_mask ()
-{
-  uint64_t mask = 0;
-
-  for (const auto &entry : x86_linux_all_tdesc_features)
-    if (entry.is_i386)
-      mask |= entry.feature;
-
-  return mask;
-}
-
-/* Return a compile time constant which is a mask of all the cpu features
-   that are checked for when building an amd64 target description.  */
-
-static constexpr uint64_t
-x86_linux_amd64_tdesc_feature_mask ()
-{
-  uint64_t mask = 0;
-
-  for (const auto &entry : x86_linux_all_tdesc_features)
-    if (entry.is_amd64)
-      mask |= entry.feature;
-
-  return mask;
-}
-
-/* Return a compile time constant which is a mask of all the cpu features
-   that are checked for when building an x32 target description.  */
-
-static constexpr uint64_t
-x86_linux_x32_tdesc_feature_mask ()
-{
-  uint64_t mask = 0;
-
-  for (const auto &entry : x86_linux_all_tdesc_features)
-    if (entry.is_x32)
-      mask |= entry.feature;
-
-  return mask;
-}
-
-/* Return a compile time constant which is a count of the number of cpu
-   features that are checked for when building an i386 target description.  */
-
-static constexpr int
-x86_linux_i386_tdesc_count ()
-{
-  uint64_t count = 0;
-
-  for (const auto &entry : x86_linux_all_tdesc_features)
-    if (entry.is_i386)
-      ++count;
-
-  gdb_assert (count > 0);
-
-  return (1 << count);
-}
-
-/* Return a compile time constant which is a count of the number of cpu
-   features that are checked for when building an amd64 target description.  */
-
-static constexpr int
-x86_linux_amd64_tdesc_count ()
-{
-  uint64_t count = 0;
-
-  for (const auto &entry : x86_linux_all_tdesc_features)
-    if (entry.is_amd64)
-      ++count;
-
-  gdb_assert (count > 0);
-
-  return (1 << count);
-}
-
-/* Return a compile time constant which is a count of the number of cpu
-   features that are checked for when building an x32 target description.  */
-
-static constexpr int
-x86_linux_x32_tdesc_count ()
-{
-  uint64_t count = 0;
-
-  for (const auto &entry : x86_linux_all_tdesc_features)
-    if (entry.is_x32)
-      ++count;
-
-  gdb_assert (count > 0);
-
-  return (1 << count);
-}
-
-#ifdef IN_PROCESS_AGENT
-
-/* See linux-x86-tdesc.h.  */
-
-int
-x86_linux_amd64_ipa_tdesc_count ()
-{
-  return x86_linux_amd64_tdesc_count ();
-}
-
-/* See linux-x86-tdesc.h.  */
-
-int
-x86_linux_x32_ipa_tdesc_count ()
-{
-  return x86_linux_x32_tdesc_count ();
-}
-
-/* See linux-x86-tdesc.h.  */
-
-int
-x86_linux_i386_ipa_tdesc_count ()
-{
-  return x86_linux_i386_tdesc_count ();
-}
-
-#endif /* IN_PROCESS_AGENT */
-
-/* Convert an xcr0 value into an integer.  The integer will be passed to
-   the in-process-agent where it will then be passed to
-   x86_linux_tdesc_idx_to_xcr0 to get back the xcr0 value.  */
-
-int
-x86_linux_xcr0_to_tdesc_idx (uint64_t xcr0)
-{
-  /* The following table shows which features are checked for when creating
-     the target descriptions (see nat/x86-linux-tdesc.c), the feature order
-     represents the bit order within the generated index number.
-
-     i386  | x87 sse mpx avx avx512 pkru
-     amd64 |         mpx avx avx512 pkru
-     i32   |             avx avx512 pkru
-
-     The features are ordered so that for each mode (i386, amd64, i32) the
-     generated index will form a continuous range.  */
-
-  int idx = 0;
-
-  for (int i = 0; i < ARRAY_SIZE (x86_linux_all_tdesc_features); ++i)
-    {
-      if ((xcr0 & x86_linux_all_tdesc_features[i].feature) != 0)
-	idx |= (1 << i);
-    }
-
-  return idx;
-}
-
-
-#ifdef IN_PROCESS_AGENT
-
-/* Convert an index number (as returned from x86_linux_xcr0_to_tdesc_idx)
-   into an xcr0 value which can then be used to create a target
-   description.  */
-
-uint64_t
-x86_linux_tdesc_idx_to_xcr0 (int idx)
-{
-  uint64_t xcr0 = 0;
-
-  for (int i = 0; i < ARRAY_SIZE (x86_linux_all_tdesc_features); ++i)
-    {
-      if ((idx & (1 << i)) != 0)
-	xcr0 |= x86_linux_all_tdesc_features[i].feature;
-    }
-
-  return xcr0;
-}
-
-#endif /* IN_PROCESS_AGENT */
-
-#if defined __i386__ || !defined IN_PROCESS_AGENT
-
-/* A cache of all possible i386 target descriptions.  */
-
-static struct target_desc *i386_tdescs[x86_linux_i386_tdesc_count ()] = { };
-
 /* See nat/x86-linux-tdesc.h.  */
 
-const struct target_desc *
-i386_linux_read_description (uint64_t xcr0)
+void
+x86_linux_post_init_tdesc (target_desc *tdesc, bool is_64bit)
 {
-  xcr0 &= x86_linux_i386_tdesc_feature_mask ();
-  int idx = x86_linux_xcr0_to_tdesc_idx (xcr0);
-
-  gdb_assert (idx >= 0 && idx < x86_linux_i386_tdesc_count ());
-
-  target_desc **tdesc = &i386_tdescs[idx];
-
-  if (*tdesc == nullptr)
-    {
-      *tdesc = i386_create_target_description (xcr0, true, false);
-
-      init_target_desc (*tdesc, i386_expedite_regs);
-    }
-
-  return *tdesc;
-}
-#endif
-
 #ifdef __x86_64__
-
-/* A cache of all possible amd64 target descriptions.  */
-
-static target_desc *amd64_tdescs[x86_linux_amd64_tdesc_count ()] = { };
-
-/* A cache of all possible x32 target descriptions.  */
-
-static target_desc *x32_tdescs[x86_linux_x32_tdesc_count ()] = { };
-
-/* See nat/x86-linux-tdesc.h.  */
-
-const struct target_desc *
-amd64_linux_read_description (uint64_t xcr0, bool is_x32)
-{
-  if (is_x32)
-    xcr0 &= x86_linux_x32_tdesc_feature_mask ();
+  if (is_64bit)
+    init_target_desc (tdesc, amd64_expedite_regs);
   else
-    xcr0 &= x86_linux_amd64_tdesc_feature_mask ();
-
-  int idx = x86_linux_xcr0_to_tdesc_idx (xcr0);
-
-  if (is_x32)
-    gdb_assert (idx >= 0 && idx < x86_linux_x32_tdesc_count ());
-  else
-    gdb_assert (idx >= 0 && idx < x86_linux_amd64_tdesc_count ());
-
-  target_desc **tdesc = nullptr;
-
-  if (is_x32)
-    tdesc = &x32_tdescs[idx];
-  else
-    tdesc = &amd64_tdescs[idx];
-
-  if (*tdesc == nullptr)
-    {
-      *tdesc = amd64_create_target_description (xcr0, is_x32, true, true);
-
-      init_target_desc (*tdesc, amd64_expedite_regs);
-    }
-  return *tdesc;
+#endif
+    init_target_desc (tdesc, i386_expedite_regs);
 }
 
-#endif
diff --git a/gdbserver/linux-x86-tdesc.h b/gdbserver/linux-x86-tdesc.h
deleted file mode 100644
index 70456e4be44..00000000000
--- a/gdbserver/linux-x86-tdesc.h
+++ /dev/null
@@ -1,50 +0,0 @@
-/* Low level support for x86 (i386 and x86-64), shared between gdbserver
-   and IPA.
-
-   Copyright (C) 2016-2024 Free Software Foundation, Inc.
-
-   This file is part of GDB.
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 3 of the License, or
-   (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
-
-#ifndef GDBSERVER_LINUX_X86_TDESC_H
-#define GDBSERVER_LINUX_X86_TDESC_H
-
-/* Convert an xcr0 value into an integer.  The integer will be passed to
-   the in-process-agent where it will then be passed to
-   x86_linux_tdesc_idx_to_xcr0 to get back the xcr0 value.  */
-
-extern int x86_linux_xcr0_to_tdesc_idx (uint64_t xcr0);
-
-#ifdef IN_PROCESS_AGENT
-
-/* Convert an index number (as returned from x86_linux_xcr0_to_tdesc_idx)
-   into an xcr0 value which can then be used to create a target
-   description.  */
-
-extern uint64_t x86_linux_tdesc_idx_to_xcr0 (int idx);
-
-/* Within the in-process-agent we need to pre-initialise all of the target
-   descriptions, to do this we need to know how many target descriptions
-   there are for each different target type.  These functions return the
-   target description count for the relevant target.  */
-
-extern int x86_linux_amd64_ipa_tdesc_count ();
-extern int x86_linux_x32_ipa_tdesc_count ();
-extern int x86_linux_i386_ipa_tdesc_count ();
-
-
-#endif /* IN_PROCESS_AGENT */
-
-#endif /* GDBSERVER_LINUX_X86_TDESC_H */